#include <iostream>
#include <boost/bind.hpp>
#include <boost/function.hpp>
#include <boost/thread/thread.hpp>
#include <boost/statechart/asynchronous_state_machine.hpp>
#include <boost/statechart/fifo_worker.hpp>

#include "StateMachine.hpp"

int main() {
    std::cout<<"\n\nPress any key and then <CR> to exit\n\n"<<std::endl;
    char key;

    boost::statechart::fifo_scheduler<> scheduler(true);
    boost::statechart::fifo_scheduler<>::processor_handle handle = scheduler.create_processor<StateMachine> ();
    scheduler.initiate_processor(handle);
    boost::thread aThread(boost::bind(&boost::statechart::fifo_scheduler<>::operator(),&scheduler, 0));

    std::cin >> key;

    scheduler.destroy_processor(handle);
    scheduler.terminate();
    aThread.join();

    return 0;
}
